/*                                                                  */
/*		(C) Tilo Lutz, TiloLutz@gmx.de								*/
/*																	*/
/*		05.11.2006 Funktionen, die nicht spezifisch sind.			*/
/*																	*/
/********************************************************************/

#include "lib.h"

// Diese Funktion wandelt einen int in einen String um.
// Die Lnge ist auf 10 Stellen+ Vorzeichen festgelegt = char[12] 
char IntToStr(char *String, int val) {
	char *origString = String;
	if (val==0) {
		*String=0x30;
		String++;
		*String=0;
		return *origString;
	}
	int zero=1;
	int erg;
	const int TEST[10] = { 1000000000, 100000000, 10000000, 1000000, 100000, 10000, 1000, 100, 10, 1 };
	if (val<0) {
		*String='-';
		String++;
		val = val * -1;
	}
	for (int i=0; i<10; i++) {
		if (val!=0) {
			erg = val / TEST[i];
			if (erg>0) {
				*String=erg+0x30;
				String++;
				val %= TEST[i];
				zero=0;
				}
			else if (!zero) {
				*String=0x30;
				String++;
			}
		}
		else {
			*String=0x30;
			String++;
		}
	*String=0;
	}
	return *origString;
}


// Bilde Potenz
int pot(int base, int power) {
	if (power==0) return 1; // Sonderregel fr 0. 0hoch0 wre unendlich, also genau genommen Fehler in Funktion
	int erg=base;
	for (int i=0; i<power; i++) // Potenziere
		erg *= power;
	return erg;
	}

// Diese Funktion wandelt einen String in Int um. Rckgabewert ist Pointer auf Int
int StrToInt(int *val, char *String) {
	*val=0;
	int len=0;
	int neg=0;
	char *workString = String;
	while (*workString!=0) { // Stelle fest, wie lang der String ist.
		len++;
		workString++;
		}
	if (*String == '-') { // Verarbeite Vorzeichen
		neg=1;
		len--;
		String++;
	}
	while (*String!=0) { // Zhle Dezimalstellen zusammen.
		len--;
		*val += (*String-0x30) * pot(10, len);
	}
	if (neg==1) *val *= -1; // passe Vorzeichen an.
	return *val;
}



/********************************************************************/
/* Verzgert die Ausfhrung des Code. Verzgerung wird in us        */
/* angegeben.                                                       */
/* Verzgerung wurde mit Osziloskop bei HCLK 5MHz bestimmt.         */
/* Funktion nur bis 300ms geeignet. Sonst luft die 32bit           */
/* Variable ber.                                                   */
/* us muss grer als 5us sein.                                     */
/* 5 <= usec <= 300000                                              */
/********************************************************************/
void udelay(int usec) {

	// kleinste mgliche Schrittweite bei 326kHz == 3us -> Teile durch 3.07
	usec *= 50;
	usec /= 307 ;
	// usec -= multiply; // Verzgerung durch Laufzeit
	// Verwende Timer0 um Verzgerung in us zu bestimmen
	T0LD = usec ; 
	T0CON = 0x88; // Aktiviere Timer und setze Prescaler auf 16
	while (T0VAL != 0) {} // Warte auf Timer
	T0CON = 0x00; //Deaktivere Timer
	T0CLRI = 0;	// Deaktivere eventuellen Interrupt.
	return;
}

void delay (int length) { // [10us]
	for (int i=0; i<length; i++)
		asm volatile ("nop");
}
