/********************************************************************/
/*                                                                  */
/*		Pulswellen Detektor											*/
/*                                                                  */
/*		(C) Tilo Lutz, TiloLutz@gmx.de								*/
/*																	*/
/*		02.11.2006 Ansteuerung DAC0									*/
/*																	*/
/********************************************************************/

// Globale Variablen
unsigned short int LED;				// Spannung die an der LED anliegt
unsigned short int Offset;			// Offsetabgleich
unsigned short int ADCBuffer[12];		// Puffer, in dem Abtastwerte abgespeichert werden
										// Es muss immer zu einem festgelegtem Zeitpunkt gemessen
										// werden, um Strungen durch LED minimal zu halten
volatile short int ControlWait;
volatile short int PulseWait;
volatile short int sleeptimer;			// Zustandsspeicher der Pause

const short int sizeoftempdatabuffer = 50;	// Gre des Array
unsigned short int tempdatabuffer[50];		// Fasse Messwerte zusammen, um 50Hz herauszufiltern.
unsigned short int tempdatabufferready;		// Speichere Mittelwert aus Messwerten

const short int sizeofdatabuffer = 50; // Gre des Array
short int databuffer[50];			// Ringpuffer speichert Messwerte
short int readpositiondatabuffer;	// Lese ab hier Messwerte auf Puffer
short int writepositiondatabuffer;	// Schreibe ab hier Messwerte in Puffer

short int p2pdistance;				// Abstand der detektierten Pulswellen
short int p2pdistancespos;			// Schreibposition im Ringspeicher
short int p2pdistances[20][2];		// Speicher fr 20 Pulswellen
									// 1. Element: Abstand zur letzten Spitze *20ms
									// 2. Element: Hhe der Spitze
const short int sizeofp2pdistances = 20; // Gre des Array
const short int PulseTime = 250;	// Zeit[s]/50ms, ber die der Puls ermittelt werden soll

// Globale Funktionen
void My_IRQ_Function(void);		// IRQ Funktion
void Init(void);					// Setze Anfangszustand des uC
void GainControl(void);			// Regelt die Intensitt der Sende-LED
void OffsetControl(void);			// Gleicht den Signaloffset ab
int GetADC(int Port);				// Gibt einen Abtastwert zurck Port ist der ADC-Port
void IntToUart(int integer);		// Sendet Integerwert ber Uart
void sleep(int time);				// Wartet x ms
